unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, SHDocVw, StdCtrls, mshtml, Grids, shellapi, DB, dxmdaset,
  dxExEdtr, dxDBCtrl, dxDBGrid, dxTL, dxCntner, ComCtrls, Buttons, ToolWin,
  cxControls, cxSplitter, dxDBTLCl, dxGrClms;

type
  TForm1 = class(TForm)
    dxMemData1: TdxMemData;
    dxMemData1StockID: TStringField;
    dxMemData1StockName: TStringField;
    dxMemData1StockType: TStringField;
    dxMemData1StockKind: TStringField;
    DataSource1: TDataSource;
    dxDBGrid1: TdxDBGrid;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    Edit1: TEdit;
    WebBrowser1: TWebBrowser;
    cxSplitter1: TcxSplitter;
    StatusBar1: TStatusBar;
    dxMemData1StockIDEh: TStringField;
    dxMemData1IssueDate: TDateField;
    SpeedButton1: TSpeedButton;
    ComboBox1: TComboBox;
    SaveDialog1: TSaveDialog;
    CoolBar2: TCoolBar;
    ToolBar2: TToolBar;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    ProgressBar1: TProgressBar;
    dxDBGrid1RecId: TdxDBGridColumn;
    dxDBGrid1StockID: TdxDBGridMaskColumn;
    dxDBGrid1StockIDEh: TdxDBGridMaskColumn;
    dxDBGrid1StockName: TdxDBGridMaskColumn;
    dxDBGrid1StockType: TdxDBGridMaskColumn;
    dxDBGrid1StockKind: TdxDBGridMaskColumn;
    dxDBGrid1IssueDate: TdxDBGridDateColumn;
    procedure WebBrowser1DocumentComplete(Sender: TObject; const pDisp: IDispatch; var URL: OleVariant);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ComboBox1CloseUp(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  IsComplete: boolean;

implementation

{$R *.DFM}

procedure TForm1.WebBrowser1DocumentComplete(Sender: TObject; const pDisp: IDispatch; var URL: OleVariant);
begin
  IsComplete := True;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  slTemp: TStringList;
  I, ii: integer;
  HTMLDoc: IHTMLDocument2;
  function GetCurrStr(sSourceStr: string): string;
  var
    iStart, iEnd: integer;
    sStr: string;
  begin
    sStr := copy(sSourceStr, 2, Length(sSourceStr) - 2);
    iStart := Pos('>', sStr);
    iEnd := Pos('<', sStr);
    result := Trim(Copy(sSourceStr, iStart + 2, iEnd - iStart - 1));
  end;
begin
  IsComplete := False;
  Cursor := crHourGlass;
  StatusBar1.SimpleText := 'bJ...';
  webbrowser1.Navigate(Edit1.Text);
  while not IsComplete do
    application.ProcessMessages;
  StatusBar1.SimpleText := '';
  Cursor := crDefault;
  HTMLDoc := webbrowser1.Document as IHTMLDocument2;
  slTemp := TStringList.Create;
  slTemp.Text := HTMLDoc.body.innerHTML;
  dxMemData1.DisableControls;
  ProgressBar1.Max := slTemp.Count;
  ii := 1;
  for I := 0 to slTemp.Count - 1 do
  begin
    if (Trim(slTemp[I]) = '<TR>') then//and ((Trim(slTemp[I + 9]) = '<TR>') or (Copy(Trim(slTemp[I + 9]), 1, 4) = '<DIV'))then
    begin
      if not dxMemData1.Locate('StockID', GetCurrStr(Trim(slTemp[I + 3])), []) then
      begin
        dxMemData1.Insert;
        dxMemData1.FieldByName('StockIDEh').AsString := GetCurrStr(Trim(slTemp[I + 2]));
        dxMemData1.FieldByName('StockID').AsString := GetCurrStr(Trim(slTemp[I + 3]));
        dxMemData1.FieldByName('StockName').AsString := GetCurrStr(Trim(slTemp[I + 4]));
        dxMemData1.FieldByName('Stockkind').AsString := GetCurrStr(Trim(slTemp[I + 5]));
        dxMemData1.FieldByName('StockType').AsString := GetCurrStr(Trim(slTemp[I + 6]));
        dxMemData1.FieldByName('IssueDate').AsString := GetCurrStr(Trim(slTemp[I + 7]));
        dxMemData1.Post;
        Inc(ii);
      end
      else
      begin
        dxMemData1.Edit;
        dxMemData1.FieldByName('StockIDEh').AsString := GetCurrStr(Trim(slTemp[I + 2]));
        dxMemData1.FieldByName('StockName').AsString := GetCurrStr(Trim(slTemp[I + 4]));
        dxMemData1.FieldByName('Stockkind').AsString := GetCurrStr(Trim(slTemp[I + 5]));
        dxMemData1.FieldByName('StockType').AsString := GetCurrStr(Trim(slTemp[I + 6]));
        dxMemData1.FieldByName('IssueDate').AsString := GetCurrStr(Trim(slTemp[I + 7]));
        dxMemData1.Post;
      end;
      ProgressBar1.Position := I;
      ProgressBar1.Update;
    end;
  end;
  ProgressBar1.Position := 0;
  dxMemData1.EnableControls;
  slTemp.Free;
end;

procedure TForm1.ComboBox1CloseUp(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
    0: Edit1.Text := '';
    1: Edit1.Text := 'http://203.74.228.63/t40/class_main.jsp?owncode=&stockname=&market=1&issuertype=&industry_code=&Page=1&chklike=Y';
    2: Edit1.Text := 'http://203.74.228.63/t40/class_main.jsp?owncode=&stockname=&market=2&issuertype=&industry_code=&Page=1&chklike=Y';
    3: Edit1.Text := 'http://203.74.228.63/t40/class_main.jsp?owncode=&stockname=&market=3&issuertype=&industry_code=&Page=1&chklike=Y';
    4: Edit1.Text := 'http://203.74.228.63/t40/class_main.jsp?owncode=&stockname=&market=4&issuertype=&industry_code=&Page=1&chklike=Y';
    5: Edit1.Text := 'http://203.74.228.63/t40/class_main.jsp?owncode=&stockname=&market=5&issuertype=&industry_code=&Page=1&chklike=Y';
  end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  SaveDialog1.FileName := '';
  SaveDialog1.Filter := 'HTML files (*.htm)|*.htm|Excel Worksheet (*.xls)|*.xls|Text files (*.txt)|*.txt|XML files (*.xml)|*.xml';
  if SaveDialog1.Execute then
  begin
    case SaveDialog1.FilterIndex of
      1: dxDBGrid1.SaveToHTML(SaveDialog1.FileName + '.htm', True);
      2: dxDBGrid1.SaveToXLS(SaveDialog1.FileName + '.xls', True);
      3: dxDBGrid1.SaveToText(SaveDialog1.FileName + '.txt', False, chr(10), '', '');
      4: dxDBGrid1.SaveToXML(SaveDialog1.FileName + '.xml', True);
    end;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if not dxMemData1.Active then
    dxMemData1.Open;
end;

end.

